#include "mpi.h"
#include "MPI_Op.h"

#define REF(x) (*(void**)&(unhand(x)->handle))

static MPI_Op Ops[] = { MPI_OP_NULL, MPI_MAX, MPI_MIN, MPI_SUM,
  MPI_PROD, MPI_LAND, MPI_BAND, MPI_LOR, MPI_BOR, MPI_LXOR,
  MPI_BXOR, MPI_MINLOC, MPI_MAXLOC};

void MPI_Op_Setup(struct HMPI_Op *this,long Type) {
  REF(this) = Ops[Type];
}

